# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_vaultaddomain`](#dsc_vaultaddomain): The DSC VaultADDomain resource type. Automatically generated from version 1.0.13
* [`dsc_vaultaddomaincontroller`](#dsc_vaultaddomaincontroller): The DSC VaultADDomainController resource type. Automatically generated from version 1.0.13
* [`dsc_vaultdownload`](#dsc_vaultdownload): The DSC VaultDownload resource type. Automatically generated from version 1.0.13
* [`dsc_vaultlocaluser`](#dsc_vaultlocaluser): The DSC VaultLocalUser resource type. Automatically generated from version 1.0.13
* [`dsc_vaultunwrap`](#dsc_vaultunwrap): The DSC VaultUnwrap resource type. Automatically generated from version 1.0.13
* [`dsc_vaultwaitforaddomain`](#dsc_vaultwaitforaddomain): The DSC VaultWaitForADDomain resource type. Automatically generated from version 1.0.13
* [`dsc_vaultwrite`](#dsc_vaultwrite): The DSC VaultWrite resource type. Automatically generated from version 1.0.13

## Resource types

### <a name="dsc_vaultaddomain"></a>`dsc_vaultaddomain`

The DSC VaultADDomain resource type.
Automatically generated from version 1.0.13

#### Properties

The following properties are available in the `dsc_vaultaddomain` type.

##### `dsc_apiprefix`

Data type: `Optional[String]`

Version of the API to use

##### `dsc_authbackend`

Data type: `Optional[String]`

The auth backend

##### `dsc_clienttoken`

Data type: `Optional[String]`

Status of the client token

##### `dsc_currentvaultvalue`

Data type: `Optional[String]`

Current Vault value

##### `dsc_databasepath`

Data type: `Optional[String]`

Path to a directory that contains the domain database

##### `dsc_dnsdelegationusername`

Data type: `Optional[String]`

Username to for DNS delegation

##### `dsc_dnsdelegationvaultpath`

Data type: `Optional[String]`

Vault path to get the secret

##### `dsc_domainadministratorusername`

Data type: `String`

Domain Administrator username

##### `dsc_domainadministratorvaultpath`

Data type: `String`

Vault path to get the secret

##### `dsc_domainnetbiosname`

Data type: `Optional[String]`

NetBIOS name for the new domain

##### `dsc_logpath`

Data type: `Optional[String]`

Path to a directory for the log file that will be written

##### `dsc_parentdomainname`

Data type: `Optional[String]`

Fully qualified name of the parent domain

##### `dsc_readresultstatus`

Data type: `Optional[String]`

Status of the current value

##### `dsc_safemodeadministratorpasswordvaultpath`

Data type: `String`

Vault path to get the secret

##### `dsc_sysvolpath`

Data type: `Optional[String]`

Path to a directory where the Sysvol file will be written

##### `dsc_vaultaddress`

Data type: `String`

Address of the Vault server

#### Parameters

The following parameters are available in the `dsc_vaultaddomain` type.

* [`dsc_domainname`](#dsc_domainname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_domainname"></a>`dsc_domainname`

namevar

Data type: `String`

Name of the domain

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_vaultaddomaincontroller"></a>`dsc_vaultaddomaincontroller`

The DSC VaultADDomainController resource type.
Automatically generated from version 1.0.13

#### Properties

The following properties are available in the `dsc_vaultaddomaincontroller` type.

##### `dsc_apipath`

Data type: `Optional[String]`

Complete API path

##### `dsc_apiprefix`

Data type: `Optional[String]`

Version of the API to use

##### `dsc_authbackend`

Data type: `Optional[String]`

The auth backend

##### `dsc_databasepath`

Data type: `Optional[String]`

 

##### `dsc_domainadministratorusername`

Data type: `String`

Domain Administrator username

##### `dsc_domainadministratorvaultpath`

Data type: `String`

Vault path to get the secret

##### `dsc_logpath`

Data type: `Optional[String]`

 

##### `dsc_safemodeadministratorpasswordvaultpath`

Data type: `String`

Vault path to get the secret

##### `dsc_sitename`

Data type: `Optional[String]`

 

##### `dsc_sysvolpath`

Data type: `Optional[String]`

 

##### `dsc_vaultaddress`

Data type: `String`

Address of the Vault server

#### Parameters

The following parameters are available in the `dsc_vaultaddomaincontroller` type.

* [`dsc_domainname`](#dsc_domainname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_domainname"></a>`dsc_domainname`

namevar

Data type: `String`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_vaultdownload"></a>`dsc_vaultdownload`

The DSC VaultDownload resource type.
Automatically generated from version 1.0.13

#### Parameters

The following parameters are available in the `dsc_vaultdownload` type.

* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_version`](#dsc_version)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_version"></a>`dsc_version`

namevar

Data type: `String`

The Vault version to download

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_vaultlocaluser"></a>`dsc_vaultlocaluser`

The DSC VaultLocalUser resource type.
Automatically generated from version 1.0.13

#### Properties

The following properties are available in the `dsc_vaultlocaluser` type.

##### `dsc_apipath`

Data type: `Optional[String]`

Complete API path

##### `dsc_apiprefix`

Data type: `Optional[String]`

Version of the API to use

##### `dsc_authbackend`

Data type: `Optional[String]`

The auth backend

##### `dsc_clienttoken`

Data type: `Optional[String]`

Status of the client token

##### `dsc_currentvaultvalue`

Data type: `Optional[String]`

Current Vault value

##### `dsc_description`

Data type: `Optional[String]`

Indicates the description you want to use for the user account

##### `dsc_disabled`

Data type: `Optional[Boolean]`

Value used to disable/enable a user account

##### `dsc_ensure`

Data type: `Enum['Present', 'Absent']`

Ensures that the feature is present or absent

##### `dsc_fullname`

Data type: `Optional[String]`

Value used to disable/enable a user account

##### `dsc_passwordchangenotallowed`

Data type: `Optional[Boolean]`

Indicates if the user can change the password

##### `dsc_passwordchangerequired`

Data type: `Optional[Boolean]`

Indicates if the user must change the password at the next sign in

##### `dsc_passwordneverexpires`

Data type: `Optional[Boolean]`

Indicates if the password will expire

##### `dsc_readresultstatus`

Data type: `Optional[String]`

Status of the current value

##### `dsc_vaultaddress`

Data type: `String`

Address of the Vault server

##### `dsc_vaultpath`

Data type: `String`

Vault path to get the secret

#### Parameters

The following parameters are available in the `dsc_vaultlocaluser` type.

* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_username`](#dsc_username)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_username"></a>`dsc_username`

namevar

Data type: `String`

Indicates the account name for which you want to ensure a specific state

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_vaultunwrap"></a>`dsc_vaultunwrap`

The DSC VaultUnwrap resource type.
Automatically generated from version 1.0.13

#### Properties

The following properties are available in the `dsc_vaultunwrap` type.

##### `dsc_apipath`

Data type: `Optional[String]`

Complete API path

##### `dsc_apiprefix`

Data type: `Optional[String]`

Version of the API to use

##### `dsc_roleid`

Data type: `String`

Value of the RoleId

##### `dsc_vaultaddress`

Data type: `String`

Address of the Vault server

#### Parameters

The following parameters are available in the `dsc_vaultunwrap` type.

* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_wrappedtoken`](#dsc_wrappedtoken)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_wrappedtoken"></a>`dsc_wrappedtoken`

namevar

Data type: `String`

Value of the wrapped token

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_vaultwaitforaddomain"></a>`dsc_vaultwaitforaddomain`

The DSC VaultWaitForADDomain resource type.
Automatically generated from version 1.0.13

#### Properties

The following properties are available in the `dsc_vaultwaitforaddomain` type.

##### `dsc_apipath`

Data type: `Optional[String]`

Complete API path

##### `dsc_apiprefix`

Data type: `Optional[String]`

Version of the API to use

##### `dsc_authbackend`

Data type: `Optional[String]`

The auth backend

##### `dsc_domainuserusername`

Data type: `String`

Domain Administrator username

##### `dsc_domainuservaultpath`

Data type: `String`

Vault path to get the secret

##### `dsc_rebootretrycount`

Data type: `Optional[Integer[0, 4294967295]]`

 

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

 

##### `dsc_retryintervalsec`

Data type: `Optional[Integer[0, 18446744073709551615]]`

 

##### `dsc_vaultaddress`

Data type: `String`

Address of the Vault server

#### Parameters

The following parameters are available in the `dsc_vaultwaitforaddomain` type.

* [`dsc_domainname`](#dsc_domainname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_domainname"></a>`dsc_domainname`

namevar

Data type: `String`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_vaultwrite"></a>`dsc_vaultwrite`

The DSC VaultWrite resource type.
Automatically generated from version 1.0.13

#### Properties

The following properties are available in the `dsc_vaultwrite` type.

##### `dsc_apipath`

Data type: `Optional[String]`

Complete API path

##### `dsc_apiprefix`

Data type: `Optional[String]`

Version of the API to use

##### `dsc_authbackend`

Data type: `Optional[String]`

The auth backend

##### `dsc_clienttoken`

Data type: `Optional[String]`

Status of the client token

##### `dsc_currentvaultvalue`

Data type: `Optional[String]`

Current Vault value

##### `dsc_forceupdate`

Data type: `Boolean`

Force the secret to be updated

##### `dsc_randomsecret`

Data type: `Boolean`

Generate a strong random secret

##### `dsc_readresultstatus`

Data type: `Optional[String]`

Status of the current value

##### `dsc_vaultaddress`

Data type: `String`

Address of the Vault server

##### `dsc_vaultvalue`

Data type: `Optional[String]`

Value for the secret

#### Parameters

The following parameters are available in the `dsc_vaultwrite` type.

* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_vaultpath`](#dsc_vaultpath)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_vaultpath"></a>`dsc_vaultpath`

namevar

Data type: `String`

Vault path to create the secret

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

